<?php
if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)die();
/** @var array $arParams */
/** @var array $arResult */
/** @global CMain $APPLICATION */
/** @global CUser $USER */
/** @global CDatabase $DB */
/** @var CBitrixComponentTemplate $this */
/** @var string $templateName */
/** @var string $templateFile */
/** @var string $templateFolder */
/** @var string $componentPath */
/** @var CBitrixComponent $component */

use Bitrix\Main\Localization\Loc;
use Bitrix\Main\Loader;
use Bitrix\Main\Web\Json;
use Grain\Iiko\Basket;

$this->setFrameMode(true);

Loc::loadMessages(__DIR__.'/template.php');

$siteId = \Bitrix\Main\Context::getCurrent()->getSite();

if($isSaleModuleInstalled=Loader::includeModule('sale'))
	$arResult['basket'] = Basket::getProductBasket($siteId);

$asset = \Bitrix\Main\Page\Asset::getInstance();

$asset->addCss($templateFolder."/js/swiper/swiper-bundle.css");
$asset->addCss($templateFolder."/js/swiper/swiper-custom.css");
$asset->addJs($templateFolder."/js/swiper/swiper-bundle.min.js");

$asset->addCss($templateFolder."/js/lightbox/lightbox.css");
$asset->addJs($templateFolder."/js/lightbox/lightbox.js");

$asset->addJs("/bitrix/components/grain/iiko.section/templates/.default/script.js");
$asset->addJs($templateFolder."/js/element.js");

$blockId = 'gi_e_'.substr(md5(mt_rand()), 0, 7);

$basketHash = Basket::encodeBasketHashForProduct($arResult['ID'],$arResult['sizes'],$arResult['modifiers']);

?>

<div class="gi-e container" itemscope itemtype="http://schema.org/Product" id="<?=$blockId?>" data-product="<?=$arResult['ID']?>">
	<meta itemprop="name" content="<?=$arResult["NAME"]?>" />
	<div class="row">
		<div class="gi-e-gallery col-md-5">
			<div class="swiper gi-e-swiper">
				<div class="swiper-wrapper">
					<?php if(!!$arResult["GALLERY"]):?>
						<?php foreach($arResult["GALLERY"] as $arPicture):?>
							<div class="swiper-slide">
								<a href="<?=$arPicture["DETAIL"]["src"]?>" data-detail-lightbox="<?=$arResult['ID']?>">
									<link itemprop="image" href="<?=$arPicture["SRC"]?>" />
									<img 
										src="<?=$arPicture["PREVIEW"]["src"]?>"
										alt="<?=$arResult["GALLERY"][0]["ORIGINAL"]["ALT"]?>"
										title="<?=$arResult["GALLERY"][0]["ORIGINAL"]["TITLE"]?>"
										<?php if($arPicture["PREVIEW"]["width"] && $arPicture["PREVIEW"]["height"]):?>width="<?=$arPicture["PREVIEW"]["width"]?>"
										height="<?=$arPicture["PREVIEW"]["height"]?>"<?php endif?>							
										/>						
								</a>
							</div>
						<?php endforeach?>
					<?php else:?>
						<div class="swiper-slide">
							<img 
								src="<?=$templateFolder?>/images/no-photo.png"
								alt="<?=$arResult["NAME"]?>"
								width="468"
								height="468"
								/>						
						</div>
					<?php endif?>
				</div>
				<?php if(count($arResult["GALLERY"])>1):?>
					<div class="swiper-button-next"></div>
					<div class="swiper-button-prev"></div>
				<?php endif?>
			</div>
			<?php if(count($arResult["GALLERY"])>1):?>
				<div class="swiper gi-e-thumb-swiper">
					<div class="swiper-wrapper">
						<?php foreach($arResult["GALLERY"] as $i=>$arPicture):?>
							<div class="swiper-slide">
								<img 
									src="<?=$arPicture["THUMBNAIL"]["src"]?>"
									alt="<?=$arResult["GALLERY"][0]["ORIGINAL"]["ALT"]?>"
									title="<?=$arResult["GALLERY"][0]["ORIGINAL"]["TITLE"]?>"
									<?php if($arPicture["THUMBNAIL"]["width"] && $arPicture["THUMBNAIL"]["height"]):?>width="<?=$arPicture["THUMBNAIL"]["width"]?>"
									height="<?=$arPicture["THUMBNAIL"]["height"]?>"<?php endif?>
									/>						
							</div>
						<?php endforeach?>
					</div>
				</div>
			<?php endif?>
		</div>
		<div class="gi-e-info col-md-7">
			<?php if($arResult["PREVIEW_TEXT"]):?>
				<div itemprop="description" class="gi-e-preview-text mb-3"><?=$arResult["PREVIEW_TEXT"]?></div>
			<?php endif?>
			<?php if(
				!!$arResult["FIELDS"] 
				|| !!$arResult["DISPLAY_PROPERTIES"]
			):?>
				<table class="table">
					<?php $i=1;if(is_array($arResult["FIELDS"])):foreach($arResult["FIELDS"] as $code=>$value):?>
						<?php if($i==0):?><thead><?php endif?>
						<?php
						if ('PREVIEW_PICTURE' == $code || 'DETAIL_PICTURE' == $code)
						{
							?><tr>
								<td><?=Loc::getMessage("IBLOCK_FIELD_".$code)?></td>
								<td class="text-right" itemprop="value"><img border="0" src="<?=$value["SRC"]?>" width="<?=$value["WIDTH"]?>" height="<?=$value["HEIGHT"]?>"/></td>
							</tr><?php
						}
						else
						{
							?><tr itemprop="additionalProperty" itemscope itemtype="http://schema.org/PropertyValue">
								<td itemprop="name"><?=Loc::getMessage("IBLOCK_FIELD_".$code)?></td>
								<td class="text-right" itemprop="value"><?=$value;?></td>
							</tr><?php
						}
						?>
						<?php if($i==0):?></thead><?php endif?>
					<?php $i++;endforeach;endif;?>
					<?php if(is_array($arResult["DISPLAY_PROPERTIES"])):foreach($arResult["DISPLAY_PROPERTIES"] as $pid=>$arProperty):
						if(in_array($pid,array($arParams["PHOTOS_PROPERTY_CODE"])))
							continue;
						?>
						<?php if($i==0):?><thead><?php endif?>
						<tr itemprop="additionalProperty" itemscope itemtype="http://schema.org/PropertyValue">
							<td itemprop="name"><?=$arProperty["NAME"]?></td>
							<td class="text-right">
								<?php if(is_array($arProperty["DISPLAY_VALUE"])):?>
									<span itemprop="value"><?=implode("</span>, <span itemprop=\"value\">", $arProperty["DISPLAY_VALUE"]);?></span>
								<?php else:?>
									<span itemprop="value"><?=$arProperty["DISPLAY_VALUE"];?></span>
								<?php endif?>
							</td>
						</tr>
						<?php if($i==0):?></thead><?php endif?>
					<?php $i++;endforeach;endif;?>
				</table>
			<?php endif?>
			<?php if($isSaleModuleInstalled):?>
				<?php if(is_array($arResult['sizes']) && count($arResult['sizes'])>0):?>
					<div class="gi-e-size-block mb-2" data-gi-s-size-block>
						<h5><?=Loc::getMessage('GRAIN_IIKO_CE_T_SIZE')?></h5>
						<?php foreach($arResult['sizes'] as $size):
							$priceFormated = \SaleFormatCurrency($size['price']['currentPrice'],$arResult['productData']['prices']['p'.$arResult['ID']]['currency']);
							?>
							<input type="radio" class="btn-check" name="size-<?=$blockId?>-<?=$arResult['ID']?>" id="radio-size-<?=$blockId?>-<?=$size['sizeId']?>" autocomplete="off" data-gi-s-size="<?=$size['sizeId']?>" <?=$size['selected']?' checked':''?>>
							<label class="btn btn-outline-primary btn-sm rounded-pill mr-2 me-2 mb-2" for="radio-size-<?=$blockId?>-<?=$size['sizeId']?>"><?=$size['s']['name']?></label>
						<?php endforeach?>
					</div>
				<?php endif?>
				<?php if(is_array($arResult['modifierFields']) && count($arResult['modifierFields'])>0):?>
					<div class="gi-e-modifier-block" data-gi-s-modifier-block>
						<?php $currentGroupName='';foreach($arResult['modifierFields'] as $modifierField):?>
							<?php if($modifierField['type']=='select'):?>
								<h5><?=$modifierField['groupName']?></h5>
								<div class="gi-e-modifier-select">
									<?php foreach($modifierField['values'] as $value):?>
										<input type="radio" class="btn-check" name="radio-mod-<?=$modifierField['groupId']?>" id="gi_s_mr_<?=$arResult['ID']?>_<?=$value['value']?>" autocomplete="off" data-gi-s-modifier-quantity value="<?=$value['value']?>" <?=$value['selected']?' checked':''?>>
										<label class="btn btn-outline-primary btn-sm rounded-pill mr-2 me-2 mb-2" for="gi_s_mr_<?=$arResult['ID']?>_<?=$value['value']?>"><?=$value['name']?></label>
									<?php endforeach?>
									<?php /*
									<select data-gi-s-modifier-quantity>
										<?php foreach($modifierField['values'] as $value):?>
											<option value="<?=$value['value']?>"<?=$value['selected']?' selected':''?>><?=$value['name']?></option>
										<?php endforeach?>
									</select>
									*/ ?>
								</div>
							<?php elseif($modifierField['type']=='checkbox'):?>
								<?php if(isset($modifierField['groupName']) && strlen($modifierField['groupName'])>0 && $modifierField['groupName']!=$currentGroupName):?>
									<h5><?=$currentGroupName=$modifierField['groupName']?></h5>
								<?php endif?>
								<label class="gi-e-modifier-name" for="gi_s_mcb_<?=$arResult['ID']?>_<?=$modifierField['id']?>"><?=$modifierField['name']?></label>
								<div class="gi-e-modifier row my-2">
									<div class="col-7 py-2"><?=\SaleFormatCurrency($modifierField['price'],$arResult['productData']['prices']['p'.$arResult['ID']]['currency'])?></div>
									<div class="col-5">
										<div class="form-check">
											<input type="checkbox" id="gi_s_mcb_<?=$arResult['ID']?>_<?=$modifierField['id']?>" class="form-check-input" autocomplete="off" data-gi-s-modifier-quantity value="<?=$modifierField['id']?>" <?=$modifierField['value']?' checked':''?>>
										</div>
									</div>
								</div>
							<?php else:?>
								<?php if(isset($modifierField['groupName']) && strlen($modifierField['groupName'])>0 && $modifierField['groupName']!=$currentGroupName):?>
									<h5><?=$currentGroupName=$modifierField['groupName']?></h5>
								<?php endif?>
								<div class="gi-e-modifier-name"><?=$modifierField['name']?></div>						
								<div class="gi-e-modifier row my-2">
									<div class="col-7 py-2"><?=\SaleFormatCurrency($modifierField['price'],$arResult['productData']['prices']['p'.$arResult['ID']]['currency'])?></div>
									<div class="col-5">
										<div class="input-group d-flex">
											<button class="btn btn-primary shadow-none" type="button" data-gi-s-number="down">-</button>
											<input type="number" class="form-control text-center shadow-none" data-gi-s-modifier-quantity="<?=$modifierField['id']?>" data-zeros="true" value="<?=$modifierField['value']?>" min="<?=$modifierField['minAmountForHtmlInput']?>"<?php if($modifierField['maxAmountForHtmlInput']):?> max="<?=$modifierField['maxAmountForHtmlInput']?>"<?php endif?>>
											<button class="btn btn-primary shadow-none" type="button" data-gi-s-number="up">+</button>
										</div>																		
									</div>
								</div>
							<?php endif?>
						<?php endforeach?>
					</div>
				<?php endif?>
				<div>
					<div class="gi-e-price p-2 mb-4 border-bottom">
						<?php foreach($arResult['ITEM_PRICES'] as $price):?>
							<?php if($price['PRICE']<$price['BASE_PRICE']):?>
								<s class="text-nowrap small text-muted" data-base-price><?=$price['PRINT_BASE_PRICE']?></s>
							<?php endif?>
							<span class="text-nowrap" data-price><?=$price['PRINT_PRICE']?></span>
						<?php endforeach?>
					</div>
					<div class="row">
						<?if($arResult['PRODUCT']['AVAILABLE']!='N'):?>
							<div class="gi-e-add-to-cart col-12 col-md-6">
								<div class="btn-group w-100 rounded overflow-hidden" role="group">
									<a href="#" class="btn btn-primary flex-grow-1 rounded-0 border-0 shadow-none" data-gi-cart-less data-hash="<?=$basketHash?>"<?php if(!$arResult['basket'][$basketHash]):?> style="display: none"<?php endif?>><?=Loc::getMessage("GRAIN_IIKO_CE_T_LESS")?></a>
									<a href="#" class="btn btn-light w-50 rounded-0 border-0 shadow-none" data-gi-cart-q data-hash="<?=$basketHash?>" data-measure="<?=isset($arResult['MEASURE']['SYMBOL'])?$arResult['MEASURE']['SYMBOL']:''?>"<?php if(!$arResult['basket'][$basketHash]):?> style="display:none"<?php endif?>><?=$arResult['basket'][$basketHash]?><?=isset($arResult['MEASURE']['SYMBOL'])?' '.$arResult['MEASURE']['SYMBOL']:''?></a>
									<a href="#" class="btn btn-primary flex-grow-1 rounded-0 border-0 shadow-none" data-gi-cart-more data-hash="<?=$basketHash?>" data-add-mess="<i class='fa fa-cart-plus'></i> <?=Loc::getMessage("GRAIN_IIKO_CE_T_ADD")?>" data-more-mess="<?=Loc::getMessage("GRAIN_IIKO_CE_T_MORE")?>"><?=$arResult['basket'][$basketHash]?Loc::getMessage("GRAIN_IIKO_CE_T_MORE"):"<i class='fa fa-cart-plus'></i> ".Loc::getMessage("GRAIN_IIKO_CE_T_ADD")?></a>
								</div>
							</div>
						<?else:?>
							<div class="gi-e-unavailable text-muted col-12 col-md-6">
								<div class="ps-2 pl-2"><?=$arParams['MESS_NOT_AVAILABLE']?$arParams['MESS_NOT_AVAILABLE']:Loc::getMessage('GRAIN_IIKO_CE_T_UNAVAILABLE')?></div>
							</div>
						<?endif?>
					</div>
				</div>
			<?php endif?>
		</div>
	</div>
	<?php if(strlen($arResult["DETAIL_TEXT"])>0):?>
		<div itemprop="description" class="gi-e-detail-text my-3"><?=$arResult["DETAIL_TEXT"]?></div>
	<?php endif?>		
</div>

<script type="text/javascript">
	var iikoElement = new GrainIikoElement({
		'selector': '#<?=$blockId?>',
		'elementId': <?=intval($arResult['ID'])?>,
		'siteId': '<?=$siteId?>',
		'restaurant': <?=Json::encode(\Grain\Iiko\Restaurants::getRestaurantByProductIblockId($arParams['IBLOCK_ID']))?>,
		'productData': <?=Json::encode($arResult['productData'])?>,
		'basket': <?=Json::encode($arResult['basket'])?>,
		'setViewedInComponent': <?=$arParams['SET_VIEWED_IN_COMPONENT']=='Y'?'true':'false'?>
	});
</script>
