function GrainIikoElement(params)
{
	this.selector = params.selector;
	this.siteId = params.siteId;
	this.restaurant = params.restaurant;
	this.productData = params.productData;
	this.elementId = params.elementId;
	this.setViewedInComponent = params.setViewedInComponent;
	this.iikoSection = new GrainIikoSection({
		'selector': this.selector,
		'siteId': this.siteId,
		'restaurant': this.restaurant,
		'productData': this.productData,
		'basket': params.basket
	});
	this.initGallery();
	this.setViewed();
}

GrainIikoElement.prototype.initGallery = function() {
	let hasThumbnails = !!document.querySelector('.gi-e-thumb-swiper');
	var swiperParams = {
		spaceBetween: 5,
		autoHeight: true,
		loop: false,
		navigation: {
			nextEl: (this.selector + ' .swiper-button-next'),
			prevEl: (this.selector + ' .swiper-button-prev')
		}
	};
	if(hasThumbnails) {
		var swiper = new Swiper(".gi-e-thumb-swiper", {
			spaceBetween: 5,
			slidesPerView: 4,
			freeMode: true,
			watchSlidesProgress: true,
			autoHeight: true
		});
		swiperParams['thumbs'] = {
			swiper: swiper
		};
	}
	var swiper2 = new Swiper(".gi-e-swiper", swiperParams);
	window.lightBox(document.querySelectorAll('.gi-e-swiper [data-detail-lightbox]'),'data-detail-lightbox');
};

GrainIikoElement.prototype.setViewed = function() {
	if(!this.setViewedInComponent)
		return;
	document.addEventListener("DOMContentLoaded", function(e) { 
		let request = new XMLHttpRequest();
		const params = "AJAX=Y&SITE_ID=" + this.siteId + "&PRODUCT_ID=" + this.elementId;//  + "&PARENT_ID="
		request.responseType = "json";
		request.open("POST", '/bitrix/components/grain/iiko.element/ajax.php', true);
		request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		request.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
		request.send(params);
	}.bind(this));
};
