<?php
if (!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED !== true) die();

use Bitrix\Main\Localization\Loc;
use Bitrix\Main\Web\Json;
use Bitrix\Main\Loader;
use Grain\Iiko\Basket;

Loc::loadMessages(__DIR__.'/template.php');

$siteId = \Bitrix\Main\Context::getCurrent()->getSite();

if($isSaleModuleInstalled=Loader::includeModule('sale'))
	$arResult['basket'] = Basket::getProductBasket($siteId);

$blockId = 'gi_s_'.substr(md5(mt_rand()), 0, 7);

?>
<div class="gi-s container" id="<?=$blockId?>">
	<?php foreach($arResult['SECTIONS'] as $section):?>
		<?php if($section['DEPTH_LEVEL']>0):?>
			<h<?=($section['DEPTH_LEVEL']+1)?>><?=$section['NAME']?></h<?=($section['DEPTH_LEVEL']+1)?>>
		<?php endif?>
		<?php
		if(!$section['ITEMS'])
			continue;
		?>
		<div class="gi-s-row row">
			<?php foreach ($section['ITEMS'] as $item):
				$uniqueId = $item['ID'].'_'.md5($this->randString().$component->getAction());
				$areaIds[$item['ID']] = $this->GetEditAreaId($uniqueId);
				$basketHash = Basket::encodeBasketHashForProduct($item['ID'],$item['sizes'],$item['modifiers']);
				$this->AddEditAction($uniqueId, $item['EDIT_LINK'], $elementEdit);
				$this->AddDeleteAction($uniqueId, $item['DELETE_LINK'], $elementDelete, $elementDeleteParams);
				?>
				<div class="col-sm-4 col-lg-3 mb-4" id="dish-<?=$item['ID']?>" data-product="<?=$item['ID']?>">
					<div class="card h-100 text-center overflow-hidden">
						<a href="<?=$item['DETAIL_PAGE_URL']?>"><img class="gi-s-image card-img-top" src="<?=is_array($item['PREVIEW_PICTURE'])?$item['PREVIEW_PICTURE']['SRC']:$templateFolder.'/images/no-photo.png'?>" alt="" /></a>
						<div class="card-body">
							<h6 class="gi-s-name card-title"><a href="<?=$item['DETAIL_PAGE_URL']?>"><?=$item['NAME']?></a></h6>
							<p class="gi-s-preview-text card-text small"><?=$item['PREVIEW_TEXT']?></p>	
						</div>
						<?php if($isSaleModuleInstalled):?>
							<div class="card-footer p-0 d-flex flex-wrap bg-light<?php /* border-top-0*/?>">
								<?php if(is_array($item['sizes']) && count($item['sizes'])>0):?>
									<div class="gi-s-size-block mb-4" data-gi-s-size-block>
										<?php foreach($item['sizes'] as $size):
											$priceFormated = \SaleFormatCurrency($size['price']['currentPrice'],$arResult['productData']['prices']['p'.$arResult['ID']]['currency']);
											?>
											<input type="radio" class="btn-check" name="size-<?=$blockId?>-<?=$item['ID']?>" id="radio-size-<?=$uniqueId?>-<?=$size['sizeId']?>" autocomplete="off" data-gi-s-size="<?=$size['sizeId']?>" <?=$size['selected']?' checked':''?>>
											<label class="btn btn-outline-primary btn-sm rounded-pill mr-2 me-2 mb-2" for="radio-size-<?=$uniqueId?>-<?=$size['sizeId']?>"><?=$size['s']['name']?></label>
										<?php endforeach?>
									</div>
								<?php endif?>
								
								<div class="gi-s-price p-2 w-100 border-bottom text-center bg-white">
									<?php foreach($item['ITEM_PRICES'] as $price):?>
										<?php if($price['PRICE']<$price['BASE_PRICE']):?>
											<s class="text-nowrap small text-muted" data-base-price><?=$price['PRINT_BASE_PRICE']?></s>
										<?php endif?>
										<span class="text-nowrap" data-price><?=$price['PRINT_PRICE']?></span>
									<?php endforeach?>
								</div>
								<?if($item['PRODUCT']['AVAILABLE']!='N'):?>
									<a href="#" class="btn btn-primary flex-grow-1 rounded-0 border-0 shadow-none" data-gi-cart-less data-hash="<?=$basketHash?>"<?php if(!$arResult['basket'][$basketHash]):?> style="display: none"<?php endif?>><?=Loc::getMessage("GRAIN_IIKO_CS_T_LESS")?></a>
									<a href="#" class="btn btn-light w-50 rounded-0 border-0 shadow-none" data-gi-cart-q data-hash="<?=$basketHash?>" data-measure="<?=isset($item['ITEM_MEASURE']['TITLE'])?$item['ITEM_MEASURE']['TITLE']:''?>"<?php if(!$arResult['basket'][$basketHash]):?> style="display:none"<?php endif?>><?=$arResult['basket'][$basketHash]?><?=isset($item['ITEM_MEASURE']['TITLE'])?' '.$item['ITEM_MEASURE']['TITLE']:''?></a>
									<a href="#" class="btn btn-primary flex-grow-1 rounded-0 border-0 shadow-none" data-gi-cart-more data-hash="<?=$basketHash?>" data-add-mess="<i class='fa fa-cart-plus'></i> <?=Loc::getMessage("GRAIN_IIKO_CS_T_ADD")?>" data-more-mess="<?=Loc::getMessage("GRAIN_IIKO_CS_T_MORE")?>"><?=$arResult['basket'][$basketHash]?Loc::getMessage("GRAIN_IIKO_CS_T_MORE"):"<i class='fa fa-cart-plus'></i> ".Loc::getMessage("GRAIN_IIKO_CS_T_ADD")?></a>
								<?else:?>
									<div class="gi-s-unavailable btn btn-light disabled border-0 w-100 text-center text-muted"><?=$arParams['MESS_NOT_AVAILABLE']?$arParams['MESS_NOT_AVAILABLE']:Loc::getMessage('GRAIN_IIKO_CS_T_UNAVAILABLE')?></div>
								<?endif?>
							</div>
						<?php endif?>
					</div>
				</div>
			<?php endforeach?>
		</div>
	<?php endforeach?>			
</div>

<script type="text/javascript">
	var iikoSection = new GrainIikoSection({
		'selector': '#<?=$blockId?>',
		'siteId': '<?=$siteId?>',
		'restaurant': <?=Json::encode(\Grain\Iiko\Restaurants::getRestaurantByProductIblockId($arParams['IBLOCK_ID']))?>,
		'productData': <?=Json::encode($arResult['productData'])?>,
		'basket': <?=Json::encode($arResult['basket'])?>
	});
</script>
