<?php
if (!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED !== true) die();

/**
 * @var CBitrixComponentTemplate $this
 * @var CatalogSectionComponent $component
 */

$component = $this->getComponent();
$arParams = $component->applyTemplateModifications();

$arResult['SECTIONS']=Array();

$resultSection = \Bitrix\Iblock\SectionTable::GetList(array(
	'order' => array('LEFT_MARGIN'=>'ASC','SORT'=>'ASC'),
	'filter' => array('IBLOCK_ID'=>$arParams['IBLOCK_ID']),
));

$addedItemId = array();
$stack = array();
while($section=$resultSection->Fetch()) 
{
	$section['ITEMS'] = Array();
	
	foreach ($arResult['ITEMS'] as $item) 
	{
		if ($item['IBLOCK_SECTION_ID']==$section['ID'])
		{
			$section['ITEMS'][] = $item;
			$addedItemId[] = $item['ID'];
		}
	}		
	if(count($section['ITEMS'])>0) 
	{
		if(count($stack)>0)
		{
			foreach($stack as $stackSection)
				if($stackSection['DEPTH_LEVEL']<$section['DEPTH_LEVEL'])
					$arResult['SECTIONS'][] = $stackSection;
			$stack = array();
		}				
		$arResult['SECTIONS'][] = $section;
	}
	else
	{
		while($lastItem=array_pop($stack))
		{
			if($lastItem['DEPTH_LEVEL']<$stackSection['DEPTH_LEVEL'])
			{
				$stack[] = $lastItem;
				break;
			}
		}
		$stack[] = $section;
	}
}

$rootItems = array();
foreach ($arResult['ITEMS'] as $item) 
{
	if(in_array($item['ID'],$addedItemId))
		continue;
	$rootItems[] = $item;
}		
if($rootItems)
{
	array_unshift($arResult['SECTIONS'], array(
		'DEPTH_LEVEL' => 0,
		'ITEMS' => $rootItems,
	)); 
}

$this->__component->SetResultCacheKeys(array(
	'ITEMS',
	'SECTIONS',
	'productData',
));
